package hsql_bsp1;

//public class  {

// Einfaches Beispiel mit Ausgabe in einem Editor
// Schalter und ComboBox vereinfachen die Aktionen

import javax.swing.*;

import java.awt.Dimension;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import java.awt.*;


import java.sql.*;
/*

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.sql.Statement;
*/

// schalter
import java.awt.event.*;

public class Hsql_Bsp1 extends JFrame implements ActionListener {
    
    String db_file_name_prefix="dbs\\hsqldb_bsp";

    JToolBar toolbar = new JToolBar();
    JTextArea inputEditor  = new JTextArea("select * from abteilung");
    JTextArea ergEditor  = new JTextArea("");
    JTextArea errorEditor  = new JTextArea("");
    JButton bnSQL;
    JButton bnESC;

    

        /** Creates a new instance of Main */
    public Hsql_Bsp1() {
        setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );
        setSize(900,500);        
        setGUI();
    }
    
    private void setGUI() {
      this.getContentPane().setLayout( new BorderLayout() );

           

    JSplitPane split = new JSplitPane(JSplitPane.VERTICAL_SPLIT,false,     
    new JScrollPane(inputEditor), new JScrollPane(ergEditor) );
    
    split.setDividerLocation(150);
      this.getContentPane().add(split, BorderLayout.CENTER);

      inputEditor.setFont( new Font("Courier New", Font.BOLD,18)  );
      ergEditor.setFont( new Font("Courier New", Font.BOLD,18)  );

      
      bnSQL = new JButton("Starte SQL");
      bnESC = new JButton("Ende");
      bnSQL.setFont( new Font("Arial", Font.BOLD,18)  );
      bnESC.setFont( new Font("Arial", Font.BOLD,18)  );


      bnSQL.addActionListener(this);
      bnESC.addActionListener(this);
        
      JPanel panel1 = new JPanel();
      panel1.setLayout(  new FlowLayout(FlowLayout.RIGHT) );
      panel1.add(bnSQL);
      panel1.add(bnESC);
      
      this.getContentPane().add(panel1, BorderLayout.NORTH);
      
    }  // setGUI

    private void bnSQL_Click() {
        String inputsql = inputEditor.getText().trim();
        String[] sqlParts = inputsql.split(";");
        for (String sql : sqlParts) {
            String sqllower = sql.toLowerCase();
            if (sqllower.contains("create") || sqllower.contains("insert") || sqllower.contains("alter table") || sqllower.contains("update"))
                changeDBS(sql);
            else
                selectDBS(sql);
        }
        
    }
    
    public  void ErrorMsg(String message, String title) {
            JOptionPane.showConfirmDialog(null,message,title,
              JOptionPane.DEFAULT_OPTION,
              JOptionPane.ERROR_MESSAGE);  // Symbol
            
        }    
    
    public void changeDBS(String sql) {
      String sDbDrv;
      String sDbUrl;

      String sUsr="sa";
      String sPwd="";

      // sDbDrv = "org.firebirdsql.jdbc.FBDriver";
      sDbDrv="org.hsqldb.jdbcDriver";
      sDbUrl="jdbc:hsqldb:"+ db_file_name_prefix;
      
        // Verbindung zur Datenbank, Auslese Variablen
      Connection cn = null;
      Statement  st = null;
      ResultSet  rs = null;
      
      ergEditor.setText("");
      try {
        Class.forName( sDbDrv );
        cn = DriverManager.getConnection( sDbUrl, sUsr, sPwd );
        st = cn.createStatement();
        
        rs = st.executeQuery( sql );
      } catch( Exception ex ) {
        System.out.println( ex );
        ErrorMsg(ex.toString(),"Fehler beim Ausführen der SQL-Statements");
      } finally {
        try { if( null != rs ) rs.close(); } catch( Exception ex ) {}
        try { if( null != st ) st.close(); } catch( Exception ex ) {}
        try { if( null != cn ) cn.close(); } catch( Exception ex ) {}
      }
    }     // sql
    
    public void selectDBS(String sql) {
      String sDbDrv;
      String sDbUrl;
      
      String sUsr="sa";
      String sPwd="";

      // sDbDrv = "org.firebirdsql.jdbc.FBDriver";
      sDbDrv="org.hsqldb.jdbcDriver";
           
      sDbUrl="jdbc:hsqldb:"+ db_file_name_prefix;
      
        // Verbindung zur Datenbank, Auslese Variablen
      Connection cn = null;
      Statement  st = null;
      ResultSet  rs = null;
      
      ergEditor.setText("");
      try {
        
        // Treiber INIT, Verbinden  und SQL-Statement auslösen
        // Returns the Class object associated with the class or interface with the given string name.
        // class c = Class.forName( sDbDrv );
        Class.forName( sDbDrv );
        
        cn = DriverManager.getConnection( sDbUrl, sUsr, sPwd );
        st = cn.createStatement();
        
        rs = st.executeQuery( sql );

        // Get meta data:
        ResultSetMetaData rsmd = rs.getMetaData();
        int i, AnzCols;
        AnzCols = rsmd.getColumnCount();
        // Ausgabe der Tabelle:
        // Oberste Zeile
        String s="";
        for( i=0; i<AnzCols; i++ ) {
          s=s+ "+---------------------" ;
        }
        s+= "+\n";
        ergEditor.append(s);
        
        s="";
        for( i=1; i<=AnzCols; i++ ) {   // Attention: first column with 1 instead of 0
          s=s+ "| " + extendStringToN( 20,rsmd.getColumnName( i ) ) ;
        }
        s=s+ "|\n" ;
        ergEditor.append(s);
        
        s="";
        for( i=0; i<AnzCols; i++ ) {
          s=s+  "+---------------------" ;
        }
        s=s+ "+\n";
        ergEditor.append(s);
        
        
          // Schleife über alle Tupel
        while( rs.next() ) {
          s="";
          for( i=1; i<=AnzCols; i++ ) { // Attention: first column with 1 instead of 0
            s=s+ "| " + extendStringToN( 20,rs.getString( i ) ) ;
          }
          s=s+ "|\n" ;  // Tupel-Ende
         
          ergEditor.append(s);
        }
        
        // Unterste Zeile
        s="";
        for( i=0; i<AnzCols; i++ ) {
          s=s+ "+---------------------" ;
        }
        s=s+ "+\n" ;
        ergEditor.append(s);
        
      } catch( Exception ex ) {
        System.out.println( ex );
        ErrorMsg(ex.toString(),"Fehler beim Ausführen der SQL-Statements");
      } finally {
        try { if( null != rs ) rs.close(); } catch( Exception ex ) {}
        try { if( null != st ) st.close(); } catch( Exception ex ) {}
        try { if( null != cn ) cn.close(); } catch( Exception ex ) {}
      }
    }     // sql


// Extend String to length of 14 characters
  private static final String extendStringToN( int iWantLen, String s )   {
    if( null == s ) s = "";
    while ( s.length() < iWantLen ) {
      s += " ";
    }
    if( s.length() > iWantLen )
        return s.substring( 0, iWantLen );
    else
        return s;
  }

    @Override
    public void actionPerformed(ActionEvent e) {
        if (e.getSource()==bnSQL) {
            bnSQL_Click();            
        }
        if (e.getSource()==bnESC) {
            this.dispose();      
        }        
    }



    
    public static void main(String[] args) {
       Hsql_Bsp1 frame = new Hsql_Bsp1();
       frame.setVisible(true);
    }

    
}
